%---------------------------------------------------------------------------
% Identification part
%---------------------------------------------------------------------------

\NeedsTeXFormat{LaTeX2e}

\ProvidesClass{polytexold}[2000/01/20]

\def\fileversion{1.5}

\RequirePackage{ifthen}
\RequirePackage{version}

\newboolean{macintosh}
\setboolean{macintosh}{false} % a modifier le cas echeant

%%\changes{1.5}{2000/01/20}{
%%De nombreuses ameliorations, en particulier la definition du
%%mode "initermediaire". Lorsque l'option de classe "intermediaire"
%%est utilisee, tous les exemple, exercices, documents definis
%%avant les commandes \chapitreexercices (...) apparaissent a
%%l'endroit ou ils ont ete definis (par exemple dans un grain).
%%  Lorsque l'option de classe "final" est utilisee, tous les
%% environnements sus-cites prennent leur place dans les les
%%annexes, classes par chapitre.
%%
%%Nouveau package hypertheorem.sty, ou on definit les environnents
%%classiques utilises en math : theoreme, proposition, lemme,
%%corollaire, definition, ainsi que leur pendants hypertheoreme
%% hyperproposition, etc.
%%
%% On utilise l'environnement demonstration (ou demo) a l'interieur
%% des environnents hypertheoreme par exemple. Par defaut, la
%% demonstration apparait alors dans les documents et un lien est
%% insere  la fin du theoreme pour y acceder. En mode "intermediaire"
%% de la classe polytex, ce fonctionnement est desactive et les demos
%% aparaissent dans le texte. En mode final, tout depend de l'option
%% de style \usepackage[plain]{hypertheorem} ou
%% \usepackage[hyperdemo]{hypertheorem}.
%%
%% Ce package est a inclure par l'utilisateur dans le preambule de 
%% son document.
%%}
%% 
%%\changes{1.41}{2000/01/20}{ 
%%Correction d'un bug (sous MacOs et Win32) dans l'environnement
%%\ungrain : suppresion de l'appel \motcle{#2} definissant un 
%%hyperlink avec le texte des mots-cles compresse (sans les blancs).
%%Cette macro supportait tres tres mal les caracteres accentues !
%%La necessite de cette macro est maintenant obsolete, car la macro
%%cours correlat utilise maintenant une liste de labels. Chaque label
%%est un (nouvel) argument optionnel de l'environnement {ungrain}.
%%On conserve cependant l'ancien systeme. Par defaut, lorsqu'il n'y
%%a pas de label, le label est le texte des mot-cles lui-meme.
%%
%% Autre point important : les modifications necessaires pour que
%% tout fonctionne bien avec hyperref >= 6.66m ont ete faites : en 
%% particulier, redefinition de \@sect et non plus \@oldsect,
%% du fait de l'inclusion tardive de nameref.sty.
%%
%% Ajout d'une nouvelle option propre/sale. L'option "propre" permet
%% d'ecrire touts les fichiers auxiliaires dans un directory portant
%% le nom aux. Lorsque l'option "propre" est choisie, le
%% directory est suppose avoir ete cree (sinon TeX n'est pas content).
%% L'option "sale" correspond a l'ancien fonctionnement (tous les 
%% fichiers auxiliaires sont cres dans le directory courant).
%%}

%%\changes{1.4}{1999/10/26}{ 
%%ajout nouvelle extension graphique .pstex
%%Economie d'un registre de fichier. On utilise tf@chap
%%pour les exe,xmp,doc aussi.
%%}


%%\changes{1.3}{1999/10/22}{
%%
%% 1. On a maintenant la possibilite d'utiliser les environnements
%% hyperexercice, hyperexemple, hyperdocument, a l'interieur
%% d'un grain. Les exercices, exemples ou documents crees sont
%% inclus dans les chapitres correspondants, apres creation d'une
%% section specifique, par exemple "Exercices de cours" pour les
%% exercices. Cela dit il faut obligatoirement creer le chapitre
%% correspondant, par exemple, \chapitreexercices, qui alors cree
%% la section sus-citee et inclut les exercices.
%% Pour ce type d'exercice, exemple ou document, un lien de retour
%% vers le grain est automatiquement insr.
%%
%% 2. Dans le pdf genere, les bookmarks respectent maintenant la
%% hierarchie section/sous-section dans les exercices, exemples et 
%% documents.
%%
%% 3. Barre de navigation en couleur + fond en couleur.
%%
%% 4. Ajout des options 10pt, 11pt, 12pt. L'option par dfaut est 12pt.
%%
%%}

%%\changes{1.2}{1999/06/30}{
%% Ajout des environnements aide et solution.
%% Decoupage de polycopie.sty en plusieurs fichiers :
%% polycopie.sty hyperpoly.sty hyperrenvois.sty hyperexercice.sty
%% hyperexemples.sty hyperdocument.sty
%%}

%% on peut donner une liste de cls dans les commandes de renvois. les pages
%% des index ont une smantique selon la graisse et la casse utilises :
%% gras pour les dfinitions
%% italiques pour les exemples et exercices
%% romain pour les documents et autres mentions 
%% gras italique pour les documents 

%%\changes{1.1}{1997/07/21}{
%% problme des mots cles sans blancs sparateurs rsolus ; on peut
%% crire dans \courscorrelat et dans le troisieme argument des grains
%% quelque chose comme <le petit chat est mort> ;
%%}

%%\changes{1.0}{1997/07/19}{
%% generation multisupport (Papier ou ecran) ^ partir d'un document
%% lectronique ;
%%}

%---------------------------------------------------------------------------
% initial code
%---------------------------------------------------------------------------


\newboolean{print}
\newboolean{intermediaire}
\newboolean{transparent}
\newboolean{polycopie}
\newboolean{propre}

\DeclareOption{10pt}{%
\gdef\ptsize{10pt}
}

\DeclareOption{11pt}{%
\gdef\ptsize{11pt}
}

\DeclareOption{12pt}{%
\gdef\ptsize{12pt}
}

\DeclareOption{ecran}{%
   \setboolean{print}{false}
   \typeout{mode ecran}
}

\DeclareOption{impression}{%
   \typeout{mode impression}
   \setboolean{print}{true}
}

\DeclareOption{intermediaire}{%
   \typeout{Mise au point : intermediaire}
   \setboolean{intermediaire}{true}
}

\DeclareOption{final}{%
   \typeout{Mise au point : final}
   \setboolean{intermediaire}{false}
}

\DeclareOption{polycopie}{%
   \typeout{forme du cours : Polycopi}
   \setboolean{polycopie}{true}
   \setboolean{transparent}{false}
}

\DeclareOption{transparent}{%
   \typeout{forme du cours : Transparents}
   \setboolean{polycopie}{false}
   \setboolean{transparent}{true}
}

\DeclareOption{propre}{%
   \setboolean{propre}{true}
}

\DeclareOption{sale}{%
   \setboolean{propre}{false}
}

%---------------------------------------------------------------------------
% Execution of options
%---------------------------------------------------------------------------

\ExecuteOptions{ecran,final,polycopie,12pt,sale}

\ProcessOptions

%---------------------------------------------------------------------------
% Choix de l'encodage des fonts : T1 au lieu de OT1 pour eviter de nombreux
% problemes lies au caracteres accentues.
%---------------------------------------------------------------------------
%---------------------------------------------------------------------------
% Choix de l'encodage des caracteres du fichier source 
% suivant la plate-forme.
%
% Pour Unix et DOS, l'encodage des
% caracteres accentues est pris en compte automatiquement par le codage T1.
% Cependant, pour le Macintosh, le codage etant different, on doit utiliser 
% en plus  \RequirePackage[mac]{inputenc}.
%---------------------------------------------------------------------------



\ifthenelse{\boolean{macintosh}}{
   \RequirePackage[T1]{fontenc}
   \RequirePackage[mac]{inputenc}
   \ifthenelse{\boolean{propre}}{
   \def\prefixe{:poly:}
   }{\def\prefixe{:}}
   \def\separateur{:}
}{
   \RequirePackage[T1]{fontenc}
   \ifthenelse{\boolean{propre}}{
   	\def\prefixe{poly/}
    }{\def\prefixe{./}}
   \def\separateur{/}
}

\xdef\jobslides{\jobname -slides}
\xdef\jobpoly{\jobname -poly}

\let\oldjobname=\jobname

\ifthenelse{\boolean{transparent}}{%
   \xdef\jobname{\prefixe\oldjobname -slides}
   \typeout{jobname = \jobname}}{%
   \xdef\jobname{\prefixe\oldjobname -poly}
   \typeout{jobname = \jobname}%
}

%---------------------------------------------------------------------------
% Class loading
%---------------------------------------------------------------------------

\ifthenelse{\boolean{transparent}}{
   \PassOptionsToClass{portrait,slidesec}{seminar}
   \LoadClass{seminar}
   \RequirePackage[francais]{babel}
   \RequirePackage{fancybox}
   \RequirePackage{ae}
   \AtBeginDocument{\RequirePackage{mathfont}}

% La solution proposee pour detecter si le fichier est en train
% d'etre compile par pdflatex est donne dans les FAQ de pdftex.
%
% On pourrait peut-etre en profiter pour supprimer la distinction
% final/intermediaire. polpoth.


   \ifx\pdfoutput\undefined        % on teste si on est dans latex
     \RequirePackage[]{hyperref}
     \RequirePackage[xdvi]{graphicx}
     \RequirePackage[xdvi]{color}
   \else                           % sinon on est dans pdflatex
     \RequirePackage[pdftex,colorlinks,hyperindex]{hyperref}
     \RequirePackage[pdftex]{graphicx}
     \RequirePackage[pdftex]{color}
   \fi

   \RequirePackage{transparent}
}{
   \ifthenelse{\boolean{print}}{
      \PassOptionsToClass{twoside}{book}
      \LoadClass[\ptsize]{book}
   }{
      \PassOptionsToClass{oneside}{book}
      \LoadClass[\ptsize]{book}
   }
%
   \ifx\pdfoutput\undefined        % on teste si on est dans latex
     \RequirePackage[]{hyperref}
     \RequirePackage[xdvi]{graphicx}
     \RequirePackage[xdvi]{color}
     \RequirePackage[xdvi]{epsfig}
     \DeclareGraphicsExtensions{.ps,.eps,.pstex}
   \else                           % sinon on est dans pdflatex
     \ifthenelse{\boolean{print}}{
        \RequirePackage[pdftex,colorlinks,linkcolor=black,hyperindex]{hyperref}
     }{
        \RequirePackage[pdftex,colorlinks,linkcolor=blue,hyperindex]{hyperref}
     }
     \RequirePackage[pdftex]{graphicx}
     \RequirePackage[pdftex]{color}
     \RequirePackage[pdftex]{epsfig}
   \fi
%
   \RequirePackage{fancyhdr}
   \RequirePackage{init2pdf}
   \RequirePackage{multind}
   \RequirePackage[francais]{babel}
   \RequirePackage{ae}
   \AtBeginDocument{\RequirePackage{mathfont}}
   \RequirePackage{frapalike}
   \RequirePackage{polycopie}
   \excludeversion{untransparent}
}

\ifthenelse{\boolean{macintosh}}{%
   \graphicspath{{:figures:}}
}{%
   \graphicspath{{figures/}}
}

\@input{acronymes.tex}

\ifx\pdfoutput\undefined   
\else
%
% Support du changement de couleur de fond d'une page,
%
% --> Propose par Antoine Grall en 1999.
%
% Ceci ne fonctionnait pas quand on utilisait french.
% Maintenant ca fonctionne au poil depuis que l'on
% utilise [francais]{babel} ! 
%
%
% Support de \href{run:fichier.truc}{text}
%
% --> Propose par Antoine Grall. Il s'agissait de mettre en
% commentaire les quatre lignes (voir plus bas)
%
\def\@hyper@launch run:#1\\#2#3{% filename, anchor text linkname
  \bgroup
    \leavevmode
    \pdfstartlink
      attr{%
        \pdfBorderAttrs\space
        /H \@pdfhighlight\space /C [\@runbordercolor]%
      }
      user {%
        /Subtype /Link
        /A <<
          /F (#1)
          /S /Launch
          \ifHy@newwindow /NewWindow true \fi
%          \ifx\\#3\\%
%          \else
%            /Win << /P (#3) /F (#1) >>
%          \fi
        >>%
      }%
    \Hy@colorlink{\@filecolor}#2%
    \close@pdflink
  \egroup
}
\fi
\endinput
